﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using DocumentFormat.OpenXml.Packaging;
using OpenXmlPowerTools;

class Program
{
    static void Main(string[] args)
    {
        FileInfo test2 = new FileInfo("../../Test2.docx");
        if (test2.Exists)
            test2.Delete();
        File.Copy("../../Test.docx", "../../Test2.docx");
        using (WordprocessingDocument wDoc = WordprocessingDocument.Open("../../Test2.docx", true))
        {
            if (RevisionAccepter.HasTrackedRevisions(wDoc))
                throw new InvalidDataException(
                    "Splitting runs will not work with documents " +
                    "that contain revision tracking.");

            // split runs in the second paragraph
            XDocument mainXDoc = wDoc.MainDocumentPart.GetXDocument();
            XElement firstParagraph = mainXDoc.Descendants(W.p).FirstOrDefault();
            if (firstParagraph != null)
            {
                XElement splitUpParagraph = RunSplitter.SplitRuns(firstParagraph);
                splitUpParagraph.Elements(W.r).Skip(13).FirstOrDefault()
                    .AddAfterSelf(
                        new XElement(W.bookmarkStart,
                            new XAttribute(W.id, 1),
                            new XAttribute(W.name, "xyz")));
                splitUpParagraph.Elements(W.r).Skip(21).FirstOrDefault()
                    .AddAfterSelf(
                        new XElement(W.bookmarkEnd,
                            new XAttribute(W.id, 1)));
                RunSplitter.CoalesceRuns(splitUpParagraph);
            }
            wDoc.MainDocumentPart.PutXDocument();
        }
    }
}
